#!/usr/bin/ruby -Ku
# coding: utf-8
# $Id: galatea_generate.rb,v 1.4 2009/02/17 05:05:46 nishimoto Exp $
# (c) Takuya NISHIMOTO 

require 'optparse'
require 'fileutils'

require File.join($self_dir, 'lib', 'generator.rb')
require File.join($self_dir, 'lib', 'app_generator.rb')
require File.join($self_dir, 'lib', 'yaml_reader.rb')

dry_run = false
ARGV.options do |opt|
  opt.on('-n', '--dry-run') do 
    dry_run = true
  end
  opt.parse!
end

target_dir = ARGV.first
unless target_dir
  puts "Usage: galatea-generate (target-dir)"
  exit
end
#top_dir = File.join(Dir.pwd, target_dir)
skel_dir = File.join($self_dir, 'skel')

args = {:verbose => true, :noop => dry_run}
FileUtils.mkdir_p target_dir, args
FileUtils.mkdir_p File.join(target_dir, 'config'), args
FileUtils.mkdir_p File.join(target_dir, 'script'), args

g = AppGenerator.new
g.config = YAMLReader.new([$self_dir + '/galatea.yml'])
#p g.config
g.dry_run = dry_run
g.dmpath = $self_dir
g.tmppath = ENV['HOME'] + "/.galatea"
g.generate skel_dir, 'runner', File.join(target_dir, 'script')
g.generate skel_dir, 'project.yml', File.join(target_dir, 'config')
FileUtils.chmod(0755, File.join(target_dir, 'script', 'runner'))
