#!/usr/bin/ruby -Ku
# coding: utf-8
# $Id: galatea_runner.rb,v 1.11 2009/02/16 15:13:20 nishimoto Exp $
# (c) Takuya NISHIMOTO 

require 'optparse'
require 'thread'

dm_conf_options = []
galatea_lang = 'ja'
rails_server = nil
dry_run = false

ARGV.options do |opt|
  opt.on('-D attr=value') do |v|
    dm_conf_options.push "-D #{v}"
  end
  opt.on('--rails-server path') do |v|
    rails_server = v       
  end
  opt.on('--config file.yml') do |v|
    file = expand_path(v)
    if File.exists?(file)
      $config_yml_array.unshift file
    end
  end
  opt.on('--lang (ja|en)') do |v|
    galatea_lang = v
  end
  opt.on('-n', '--dry-run') do |v|
    dry_run = true
  end
  opt.parse!
end

m = GalateaConfigMaker.new($config_yml_array)
m.set_dm_options dm_conf_options, ARGV
m.set_lang galatea_lang
m.mkdir_tmppath
%w[ julius.conf gdm.conf fsm.conf ssm.conf chasenrc-euc-jp am.conf am_mcl.conf ].each do |f|
  m.make f
end
unless m.env_ok?
  puts m.errors.join("¥n")
  exit
end
if rails_server
  #server_cmd = "kterm -e sh -c '#{m.param('rails.ruby.bin')} #{rails_server}/script/server' &"
  server_cmd = "#{m.param('rails.ruby.bin')} #{rails_server}/script/server"
else
  server_cmd = nil
end
if dry_run
  puts '[server] ' + server_cmd if server_cmd
  puts '[runner] ' + m.runner_cmd
else
  #system server_cmd if server_cmd
  if server_cmd
    Thread.start do
      system server_cmd
    end
  end
  system m.runner_cmd
end
exit

# end of file
