#!/usr/bin/env ruby -Ku
# coding: utf-8
# installer of /usr/local/istc-galatea-dialog
# $Id: setup_dialog.rb,v 1.5 2009/03/31 12:16:11 nishimoto Exp $
# usage:
# $ cd linux/setup/dialog/files
# $ sudo ruby setup-dialog.rb
# making deb package (using checkinstall)
# - http://d.hatena.ne.jp/nishimotz/20090218/1234967818

require 'fileutils'

EXIT_SUCCESS = 0
EXIT_FAILURE = -1
CHECK_TARGET = "/usr/local/istc-galatea-dialog"
dir = ARGV.first
unless dir
  puts "setup_dialog.rb (path/to/eclipse/workspace/galatea)"
  exit
end

files = []
%w[ files bin ].each do |f|
  files << "#{dir}/#{f}"
end

if FileTest.exist?(CHECK_TARGET)
  puts "#{CHECK_TARGET} is already installed" 
  exit EXIT_SUCCESS
end

begin
  FileUtils.mkdir_p CHECK_TARGET
  FileUtils.cp_r files, CHECK_TARGET, :preserve => true
rescue => e
  puts e.message
  exit
end

begin
  File.open("/usr/local/bin/galatea-generate", "w") do |outfile|
    outfile.write <<"EOS"
#!/usr/bin/ruby -Ku
# coding: utf-8
load '/usr/local/istc-galatea-dialog/files/galatea-generate'
EOS
  end
  FileUtils.chmod 0755, "/usr/local/bin/galatea-generate"
rescue => e
  puts e.message
  exit
end

begin
  File.open("/usr/local/bin/galatea-runner", "w") do |outfile|
    outfile.write <<"EOS"
#!/usr/bin/ruby -Ku
# coding: utf-8
load '/usr/local/istc-galatea-dialog/files/galatea-runner'
EOS
  end
  FileUtils.chmod 0755, "/usr/local/bin/galatea-runner"
rescue => e
  puts e.message
  exit
end

if FileTest.exist?(CHECK_TARGET)
  puts "#{CHECK_TARGET} is succssfully installed" 
  exit EXIT_SUCCESS
end

puts "Error: #{CHECK_TARGET} cannot be installed" 
exit EXIT_FAILURE
