#!/usr/bin/env ruby -Ku
# coding: utf-8
# installer of /usr/local/istc
# $Id: setup_engine.rb,v 1.2 2009/03/31 11:59:15 nishimoto Exp $
# usage:
# $ cd linux/setup/engine
# $ sudo ruby setup-engine.rb
# making deb package (using checkinstall)
# - http://d.hatena.ne.jp/nishimotz/20090218/1234967818

require 'fileutils'

EXIT_SUCCESS = 0
EXIT_FAILURE = -1
CHECK_TARGET = "/usr/local/istc-galatea-engine"

dir = File.expand_path(Dir.pwd)
files = []
%w[ 00README.utf8.txt AM DM1 FSM SRM SSM TM ].each do |f|
  files << "#{dir}/#{f}"
end

if FileTest.exist?(CHECK_TARGET)
  puts "#{CHECK_TARGET} is already installed" 
  exit EXIT_SUCCESS
end

#puts files.join(' ')

FileUtils.mkdir_p CHECK_TARGET
FileUtils.cp_r files, CHECK_TARGET, :preserve => true

if FileTest.exist?(CHECK_TARGET)
  puts "#{CHECK_TARGET} is succssfully installed" 
  exit EXIT_SUCCESS
end

puts "Error: #{CHECK_TARGET} cannot be installed" 
exit EXIT_FAILURE
